package checkout;

import java.io.*;
import java.sql.*;
import java.util.Vector;
import java.math.BigDecimal;

public class ItemList {
	private Vector<Object> list;
	private Item item;
	
	public ItemList() {
		list = new Vector<Object>();
	}
	
	public void setItemListBySubCategory(int subcat) throws SQLException, java.lang.InstantiationException, java.lang.IllegalAccessException, ClassNotFoundException {
		Class.forName("com.mysql.jdbc.Driver").newInstance();
		Connection con = null;
		PreparedStatement pstmt = null;
		ResultSet rs = null;

		try {
			con = DriverManager.getConnection("jdbc:mysql://" + MySQLDB.getHost() + "/" + MySQLDB.getDatabase(), 
				MySQLDB.getUsername(), MySQLDB.getPassword());
			pstmt = con.prepareStatement("SELECT subcat.id AS subcatid, subcat.name AS subcatname, item.id AS itemid, item.name AS itemname, price FROM (subcat LEFT JOIN itemlist ON subcat.id = itemlist.subcat) LEFT JOIN item ON itemlist.item = item.id WHERE subcat.id = ?");
			pstmt.setInt(1, subcat);
			rs = pstmt.executeQuery();

			while(rs.next()) {
				Item b = new Item(rs.getInt("subcatid"),
					rs.getString("subcatname"),
					rs.getInt("itemid"),
					rs.getString("itemname"),
					rs.getBigDecimal("price"));
				list.add(b);
			}
		}
		catch(SQLException e) {
			throw e;
		}
		finally {
			if (rs != null) rs.close();
			if (pstmt != null) pstmt.close();
			if (con != null) con.close();
		}
	}
	
	public void setItemListByItemId(int id) throws SQLException, java.lang.InstantiationException, java.lang.IllegalAccessException, ClassNotFoundException {
		Class.forName("com.mysql.jdbc.Driver").newInstance();
		Connection con = null;
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		
		try {
			con = DriverManager.getConnection("jdbc:mysql://" + MySQLDB.getHost() + "/" + MySQLDB.getDatabase(), 
				MySQLDB.getUsername(), MySQLDB.getPassword());
			pstmt = con.prepareStatement("SELECT subcat.id AS subcatid, subcat.name AS subcatname, item.id AS itemid, item.name AS itemname, price, description FROM (subcat LEFT JOIN itemlist ON subcat.id = itemlist.subcat) LEFT JOIN item ON itemlist.item = item.id WHERE item.id = ?");
			pstmt.setInt(1, id);
			rs = pstmt.executeQuery();
			
			while(rs.next()) {
				Item b = new Item(rs.getInt("subcatid"),
					rs.getString("subcatname"),
					rs.getInt("itemid"),
					rs.getString("itemname"),
					rs.getBigDecimal("price"),
					rs.getClob("description"));
				list.add(b);
			}
			
			for(int i = 0; i < list.size(); i++) {
				item = (Item) list.elementAt(i);
			}
		}
		catch(SQLException e) {
			throw e;
		}
		finally {
			if (rs != null) rs.close();
			if (pstmt != null) pstmt.close();
			if (con != null) con.close();
		}
	}

	public Vector getItemList() {
		return list;
	}
	
	public Item getItem() {
		return item;
	}
}