package checkout;

import java.io.*;
import java.sql.*;
import java.util.Vector;

public class SubCategoryList {
	private Vector<Object> list;
	private SubCategory subcat;
	
	public SubCategoryList() {
		list = new Vector<Object>();
	}
	
	public void setSubCategoryListByCategory(int category) throws SQLException, java.lang.InstantiationException, java.lang.IllegalAccessException, ClassNotFoundException {
		Class.forName("com.mysql.jdbc.Driver").newInstance();
		Connection con = null;
		PreparedStatement pstmt = null;
		ResultSet rs = null;

		try {
			con = DriverManager.getConnection("jdbc:mysql://" + MySQLDB.getHost() + "/" + MySQLDB.getDatabase(), 
				MySQLDB.getUsername(), MySQLDB.getPassword());
			pstmt = con.prepareStatement("SELECT cat.id AS catid, cat.name AS catname, subcat.id AS subcatid, subcat.name AS subcatname FROM (cat LEFT JOIN catlist ON cat.id = catlist.cat) LEFT JOIN subcat ON catlist.subcat = subcat.id WHERE cat.id = ?");
			pstmt.setInt(1, category);
			rs = pstmt.executeQuery();

			while(rs.next()) {
				SubCategory b = new SubCategory(rs.getInt("catid"),
				rs.getString("catname"),
				rs.getInt("subcatid"),
				rs.getString("subcatname"));
				list.add(b);
			}
		}
		catch(SQLException e) {
			throw e;
		}
		finally {
			if(rs != null) rs.close();
			if(pstmt != null) pstmt.close();
			if(con != null) con.close();
		}
	}

	public void setSubCategoryListById(int id) throws SQLException, java.lang.InstantiationException, java.lang.IllegalAccessException, ClassNotFoundException {
		Class.forName("com.mysql.jdbc.Driver").newInstance();
		Connection con = null;
		PreparedStatement pstmt = null;
		ResultSet rs = null;

		try {
			con = DriverManager.getConnection("jdbc:mysql://" + MySQLDB.getHost() + "/" + MySQLDB.getDatabase(), 
				MySQLDB.getUsername(), MySQLDB.getPassword());
			pstmt = con.prepareStatement("SELECT cat.id AS catid, cat.name AS catname, subcat.id AS subcatid, subcat.name AS subcatname FROM (cat LEFT JOIN catlist ON cat.id = catlist.cat) LEFT JOIN subcat ON catlist.subcat = subcat.id WHERE subcat.id = ?");
			pstmt.setInt(1, id);
			rs = pstmt.executeQuery();

			while(rs.next()) {
				SubCategory b = new SubCategory(rs.getInt("catid"),
				rs.getString("catname"), 
				rs.getInt("subcatid"),
				rs.getString("subcatname"));
				list.add(b);
			}
			
			for(int i = 0; i < list.size(); i++) {
				subcat = (SubCategory) list.elementAt(i);
			}
		}
		catch(SQLException e) {
			throw e;
		}
		finally {
			if(rs != null) rs.close();
			if(pstmt != null) pstmt.close();
			if(con != null) con.close();
		}
	}

	public Vector getSubCategoryList() {
		return list;
	}
	
	public SubCategory getSubCategory() {
		return subcat;
	}
}