use mall;
-- categories
create table cat (
	id int unsigned not null auto_increment,
	name varchar(32) not null,
	primary key(id)
);
-- subcategories
create table subcat (
	id int unsigned not null auto_increment,
	name varchar(32) not null,
	primary key(id)
);
-- indexes of subcategories linked with categories
create table catlist (
	id int unsigned not null auto_increment,
	cat int unsigned not null,
	subcat int unsigned not null,
	primary key(id)
);
-- items
create table item (
	id int unsigned not null auto_increment,
	name varchar(128) not null,
	price decimal(8,2) unsigned not null,
	description text,
	primary key(id)
);
-- indexes of items linked with subcategories
create table itemlist (
	id int unsigned not null auto_increment,
	item int unsigned not null,
	subcat int unsigned not null,
	primary key(id)
);
-- users
create table user (
	id serial,
	name varchar(32) not null,
	passwd varchar(32) not null,
	email varchar(120) not null,
	`group` enum('customer', 'employee', 'admin') not null default 'customer'
);
-- final order
create table `order` (
	id int unsigned not null auto_increment,
	user bigint unsigned not null,
	address varchar(32) not null,
	zip varchar(32) not null,
	country char(2) not null,
	card tinyblob not null,
	expmonth char(2) not null,
	expyear varchar(4) not null,
	time datetime not null,
	primary key(id)
);
-- individual items in final order
create table suborder (
	id int unsigned not null auto_increment,
	item int unsigned not null,
	quantity int unsigned not null,
	`order` int unsigned not null,
	primary key(id)
);